
const mapTemplateToTable = {
  '所属平台ID': 'platform_id',
  '供应商公司编码': 'supplierNo',
  '销售方公司编码': 'companyNo',
  '购买方公司编码': 'customerNo',
  '一级品类ID': 'cat_id1',
  '二级品类ID': 'cat_id2',
  '三级品类ID': 'cat_id',
  '商品单位ID': 'good_unit',
  '税率': 'good_tax',
  '单据号': 'workCode',
  'PO编号': 'poCode',
  '收货人': 'contactor',
  '联系电话': 'mobile',
  '发货时间': 'sendtime',
  '联系地址': 'addr',
  '商品名称': 'good_name',
  '数量': 'good_num',
  '销售单价': 'sale_price',
  '采购单价': 'cgd_price',
  '采购毛利率': 'cgd_tax',
  '销售总额': 'good_total'
  // '销售方公司名称': 'value0',
  // '购买方公司名称': 'value1',
  // '供应商公司名称': 'value2',
}

export const getTableProperty = (key) => mapTemplateToTable[key]
export const PROPERTYS = {
  COMPANY_NO: getTableProperty('销售方公司编码'),
  CUSTOMER_NO: getTableProperty('购买方公司编码'),
  SUPPLIER_NO: getTableProperty('供应商公司编码'),
  PLATFORM: getTableProperty('所属平台ID'),
  CATEGORY: getTableProperty('三级品类ID'),
  GOOD_NAME: getTableProperty('商品名称'),
  GOOD_UNIT: getTableProperty('商品单位ID'),
  GOOD_NUM: getTableProperty('数量'),
  GOOD_PRICE: getTableProperty('销售单价'),
  TAX: getTableProperty('税率'),
  CGD_PRICE: getTableProperty('采购单价'),
  CGD_TAX: getTableProperty('采购单毛利率'),
  GOOD_TOTAL: getTableProperty('销售总额'),
  CONTACTOR: getTableProperty('收货人'),
  MOBILE: getTableProperty('联系电话'),
  ADDR: getTableProperty('联系地址'),
  SEND_TIME: getTableProperty('发货时间'),
  PO_CODE: getTableProperty('PO编号'),
  WORK_CODE: getTableProperty('单据号')
}

export const template = Array(1).fill(1).map(() => Object.keys(mapTemplateToTable).reduce((prev, property) => {
  prev[property] = ''
  return prev
}, {}))

export const columns = [
  {
    type: 'index',
    label: '序号',
    width: '70px'
  },
  // {
  //   prop: getTableProperty('销售方公司名称'),
  //   label: '销售方公司名称',
  //   width: '156px'
  // },
  // {
  //   prop: getTableProperty('购买方公司名称'),
  //   label: '购买方公司名称',
  //   width: '180px'
  // },
  // {
  //   prop: getTableProperty('供应商公司名称'),
  //   label: '供应商公司名称',
  //   width: '120px'
  // },
  {
    prop: PROPERTYS.PLATFORM,
    label: '所属平台ID',
    width: '110px',
    required: true
  },
  {
    prop: PROPERTYS.SUPPLIER_NO,
    label: '供应商公司编码',
    width: '120px',
    required: true
  },
  {
    prop: PROPERTYS.COMPANY_NO,
    label: '销售方公司编码',
    width: '156px',
    required: true
  },
  {
    prop: PROPERTYS.CUSTOMER_NO,
    label: '购买方公司编码',
    width: '180px',
    required: true
  },

  {
    prop: getTableProperty('一级品类ID'),
    label: '一级品类ID',
    width: '150px',
    required: true
  },
  {
    prop: getTableProperty('二级品类ID'),
    label: '二级品类ID',
    width: '150px',
    required: true
  },
  {
    prop: getTableProperty('三级品类ID'),
    label: '三级品类ID',
    width: '150px',
    required: true
  },
  {
    prop: PROPERTYS.GOOD_UNIT,
    label: '商品单位ID',
    width: '150px',
    required: true
  },
  {
    prop: PROPERTYS.TAX,
    label: '税率',
    width: '150px',
    required: true
  },
  {
    prop: PROPERTYS.WORK_CODE,
    label: '单据号',
    'width': '150px'
  },
  {
    prop: PROPERTYS.PO_CODE,
    label: 'PO编号',
    'width': '150px',
    required: true
  },
  {
    prop: PROPERTYS.CONTACTOR,
    label: '收货人',
    'width': '150px',
    required: true
  },
  {
    prop: PROPERTYS.MOBILE,
    label: '联系电话',
    'width': '150px',
    required: true
  },
  {
    prop: PROPERTYS.SEND_TIME,
    label: '发货时间',
    'width': '150px',
    required: true
  },
  {
    prop: PROPERTYS.ADDR,
    label: '联系地址',
    'width': '150px',
    required: true
  },
  {
    prop: PROPERTYS.GOOD_NAME,
    label: '商品名称',
    width: '150px',
    required: true
  },
  {
    prop: PROPERTYS.GOOD_NUM,
    label: '数量',
    width: '140px',
    required: true
  },
  {
    prop: PROPERTYS.GOOD_PRICE,
    label: '销售单价',
    'width': '150px',
    required: true
  },
  {
    prop: PROPERTYS.CGD_PRICE,
    label: '采购单价',
    'width': '150px',
    required: true
  },
  {
    prop: PROPERTYS.CGD_TAX,
    label: '采购毛利率',
    'width': '150px'
  },
  {
    prop: PROPERTYS.GOOD_TOTAL,
    label: '销售总额',
    'width': '150px'
  }
]

export function createErrorMessage(messages) {
  const rows = Object.keys(messages)
  return rows.reduce((prev, row, index) => {
    const suffix = index === rows.length - 1 ? '</ul>' : ''

    const content = prev + `
      <li>
        <strong style="font-weight:700">第${row}行</strong>,${messages[row]}
      </li>
    `
    return content + suffix
  }, '<ul>')
}

export const createFieldVerification = (message) => ({
  notValidRows: [],
  isValid: true,
  message
})

export const requsetFields = [
  PROPERTYS.TAX,
  PROPERTYS.ADDR,
  PROPERTYS.MOBILE,
  PROPERTYS.PO_CODE,
  PROPERTYS.PLATFORM,
  PROPERTYS.CATEGORY,
  PROPERTYS.GOOD_NAME,
  PROPERTYS.GOOD_UNIT,
  PROPERTYS.GOOD_NUM,
  PROPERTYS.CGD_PRICE,
  PROPERTYS.CONTACTOR,
  PROPERTYS.SEND_TIME,
  PROPERTYS.WORK_CODE,
  PROPERTYS.GOOD_PRICE,
  PROPERTYS.COMPANY_NO,
  PROPERTYS.SUPPLIER_NO,
  PROPERTYS.CUSTOMER_NO
]

export const requiredFields = [
  PROPERTYS.ADDR,
  PROPERTYS.PO_CODE,
  PROPERTYS.CATEGORY,
  PROPERTYS.PLATFORM,
  PROPERTYS.CONTACTOR,
  PROPERTYS.SEND_TIME,
  PROPERTYS.GOOD_NAME,
  PROPERTYS.GOOD_UNIT
]

export const numberFields = [
  PROPERTYS.TAX,
  PROPERTYS.GOOD_NUM,
  PROPERTYS.CGD_PRICE,
  PROPERTYS.GOOD_PRICE
]

export const helper = {
  fields(sourceObject) {
    return Object.keys(sourceObject)
  },
  values(sourceObject, fields, index = 0) {
    return fields.map(field => {
      return sourceObject[field][index]
    })
  },
  write(sourceObject, fields) {
    return fields.reduce((prev, currentKey) => ({
      ...prev,
      [currentKey]: sourceObject[currentKey]
    }), {})
  }
}
